# FPGA_CNN

**简介：**

自从MINIST数据集出现以来，基于其的手写数字识别准确率一度成为了基础神经网络模型性能的衡量标准，目前在Windows和Linux上面的深度学习框架和神经网络运算加速器（GPU、TPU等等）对神经网络模型计算带来了很大优化，但这些方法往往对一些固化的边端设备不太适用。基于此，在FPGA支持下使用Verilog语言设计一个CNN网络来测量模型在可编程器件上的性能表现，并在Vivado 2018版本打包成ip核可进行使用。

**主要功能：**

该算法基于tensorflow后端生成模型，算法输入为像素大小为320x240的灰度图像的数字信息，输出为图像识别结果。该算法能够测量基础CNN模型在FPGA上的性能，同时可以根据需要选择不同位宽进行测试。此外在代码的实现过程中，参考了Suisuisi[1]、Shvlad[2]等项目经验。

**模型框架示意图：**

| 算法名称   | 基于Verilog HDL语言的数字图像识别                 |
| :--------- | ------------------------------------------------- |
| 算法接口   | testbench_CNN.v，generator_image_for_testbench.py |
| 输入       | 图像文件                                          |
| 输出       | 识别结果                                          |
| 支持数据集 | MINIST                                            |
| 依赖库     | Vivado 2018开发软件，FPGA                         |
| 参考资源   | Suisuisi、Shvlad等                                |

**参考文献**

[1] https://github.com/suisuisi/FPGAandCNN

[2] https://habr.com/en/post/283488/
